unit uMain; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs,
  mysql50conn, sqldb, DB, DBGrids, DBCtrls, Buttons, ActnList, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    act_genSQupdate: TAction;
    act_commit: TAction;
    act_close: TAction;
    act_open: TAction;
    ActionList1: TActionList;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    CheckBox1: TCheckBox;
    Datasource1: TDatasource;
    DBEdit1: TDBEdit;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    Memo1: TMemo;
    Memo2: TMemo;
    MySQL50Connection1: TMySQL50Connection;
    SQLQuery1: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure FormDestroy(Sender: TObject);
    procedure SQLQuery1AfterPost(DataSet: TDataSet);
    procedure act_closeExecute(Sender: TObject);
    procedure act_commitExecute(Sender: TObject);
    procedure act_genSQupdateExecute(Sender: TObject);
    procedure act_openExecute(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation





{ TForm1 }

procedure TForm1.act_openExecute(Sender: TObject);
begin
  if not SQLQuery1.active then SQLQuery1.active := true;
end;

procedure TForm1.act_closeExecute(Sender: TObject);
begin
  if SQLQuery1.active then SQLQuery1.active := false;
end;

procedure TForm1.act_commitExecute(Sender: TObject);
begin
  if SQLQuery1.active then
  begin
//    if SQLQuery1.State =  SQLQuery1.Post;
    act_genSQupdateExecute(Sender);
    SQLQuery1.ApplyUpdates;
    SQLTransaction1.Commit;
  end;
end;

procedure TForm1.act_genSQupdateExecute(Sender: TObject);
  var
    s : string;
    qry : tsqlquery;
    x   : integer;
    Fld : TField;

  procedure UpdateWherePart(var sql_where : string;x : integer);

  begin
    with SQLQuery1 do
    begin
      if (pfInKey in Fields[x].ProviderFlags) or
         ((UpdateMode = upWhereAll) and (pfInWhere in Fields[x].ProviderFlags)) or
         ((UpdateMode = UpWhereChanged) and (pfInWhere in Fields[x].ProviderFlags) and (fields[x].value <> fields[x].oldvalue)) then
        sql_where := sql_where + '(' + fields[x].FieldName + '= :OLD_' + fields[x].FieldName + ') and ';
    end;
  end;

  function ModifyRecQuery : string;

  const Tablename = 'clients';

  var x          : integer;
      sql_set    : string;
      sql_where  : string;

  begin
    with SQLQuery1 do
    begin
      sql_set := '';
      sql_where := '';
      for x := 0 to Fields.Count -1 do
        begin
        UpdateWherePart(sql_where,x);

        if (pfInUpdate in Fields[x].ProviderFlags) then
          sql_set := sql_set + fields[x].FieldName + '=:' + fields[x].FieldName + ',';
        end;

      setlength(sql_set,length(sql_set)-1);
      setlength(sql_where,length(sql_where)-5);
      result := 'update ' + TableName + ' set ' + sql_set + ' where ' + sql_where;
    end;
  end;

begin

  s := ModifyRecQuery;
  Memo2.Clear;
  Memo2.Lines.Add(s);
  with SQLQuery1 do
  begin
    qry := tsqlquery.Create(self);
    qry.SQL.Add(s);
    with qry do
      begin
      for x := 0 to Params.Count-1 do with params[x] do if leftstr(name,4)='OLD_' then
        begin
        Fld := SQLQuery1.FieldByName(copy(name,5,length(name)-4));
        AssignFieldValue(Fld,Fld.OldValue);
        end
      else
        begin
        Fld := SQLQuery1.FieldByName(name);
        AssignFieldValue(Fld,Fld.Value);
        end;
  //    execsql;
      end;
  end;
end;

procedure TForm1.SQLQuery1AfterPost(DataSet: TDataSet);
begin
  if SQLQuery1.active then Memo1.Lines.Assign(SQLQuery1.UpdateSQL);
  CheckBox1.Checked := SQLQuery1.ReadOnly;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  act_closeExecute(Sender);
end;

initialization
  {$I uMain.lrs}

end.

